#include <windows.h>
#include <fstream>
#include <cstring>
#include"ids.h"

using namespace std;
/* Declare Windows procedure */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);



/* Make the class name into a global variable */
char szClassName[ ] = "WindowsApp";
int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof(WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL; /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* pone algo de color en el fondo de la ventana */
    wincl.hbrBackground = (HBRUSH)CreateSolidBrush(RGB(255,235,245));

    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&wincl)) return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx(
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Ejemplo de Edicin EDIT y STATIC",         /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           544,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           LoadMenu(hThisInstance,"Menu"),
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow(hwnd, nFunsterStil);
    /* Run the message loop. It will run until GetMessage( ) returns 0 */
    while(GetMessage(&messages, NULL, 0, 0))
    {
           /* Translate virtual-key messages into character messages */
           TranslateMessage(&messages);
           /* Send message to WindowProcedure */
           DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage( ) gave */
    return messages.wParam;
}

/* This function is called by the Windows function DispatchMessage( ) */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInst;  // declaradas static, para que al volver al
    static HWND hwndEdit ;   // procedimiento, no se pierdan estas
    static HFONT hFont;      // variables.
    static HWND hwndStatic;
    ifstream Archivo ;
    ofstream Salida ;
    char texto[250];
    char szText[500];
    switch (message)                  /* handle the messages */
    {
        case WM_CREATE :
           hInst = ((LPCREATESTRUCT)lParam)->hInstance;
         //  ver al final del archivo explicacin dec CreateFont
         //  aca se define, el tipo de letra a usar
           hFont = CreateFont(14, 0, 0, 0, 100, 0, 0, 0,0, 0, 0, 0,
                   VARIABLE_PITCH | FF_SWISS, "Verdana");

           break;
        case WM_COMMAND :
           if ( LOWORD(wParam) == CM_CREAR )
             {
                  // ventana que permite editar texto, acepta modificaciones
             hwndEdit = CreateWindowEx
              (      WS_EX_CLIENTEDGE,
                  "EDIT","",
                  WS_CHILD | WS_VSCROLL
                  | ES_MULTILINE | WS_VISIBLE | WS_BORDER,
                  5, 5, 350, 250, hwnd,  NULL, hInst, NULL
              );
                 // ventana  que permite mostrar texto, pero sin modificar
             hwndStatic = CreateWindowEx (  WS_EX_CLIENTEDGE, "STATIC","",
                  WS_CHILD | WS_VISIBLE | WS_BORDER ,
                   355, 5,174,250, hwnd,  NULL, hInst, NULL  );
                // se carga el tipo de letra, definido a la ventana EDIT
             SendMessage(hwndEdit,WM_SETFONT,(WPARAM)hFont,TRUE);
                // se  habre el archivo
             Archivo.open("entrada.txt");
             if (  Archivo.fail())
              {
                  MessageBox(hwnd, "No se pudo abrir archivo", "WinMain", MB_ICONEXCLAMATION);
                   break ;
              }
                // lee el texto
            strcpy(szText,"");
            while ( !Archivo.eof() )
             {
                 Archivo.getline(texto,250,'\n');
                 strcat(szText,texto);
                 strcat(szText,"  ");
              }
             Archivo.close();
                // enviar texto a la ventana de Edicin
             SendMessage(hwndEdit, WM_SETTEXT, 0, (long int) szText );
                // enviar el mismo texto a la ventana STATIC
             SendMessage(hwndStatic, WM_SETTEXT, 0, (long int) szText );
           }  // fin del if de creacin de la ventana

           if ( LOWORD(wParam) == CM_GUARDAR)
            {
               Salida.open("salida.txt");
                // recupera el texto de la ventana en el string szText
               GetWindowText(hwndEdit,  szText, 500) ;
               Salida  << szText << "*" ;
               Salida.close();
            }   // fin del if de GUARDAR
         if ( LOWORD(wParam) == CM_CERRAR )
            DestroyWindow(hwndEdit);
           break;
        case WM_DESTROY:
           PostQuitMessage(0);        /* send a WM_QUIT to the message queue */
           break;
        default:                   /* for messages that we don't deal with */
           return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}
/*
HFONT CreateFont(
  int nHeight,             // logical height of font
  int nWidth,              // logical average character width
  int nEscapement,         // angle of escapement
  int nOrientation,        // base-line orientation angle
  int fnWeight,            // font weight    rango [0-1000]
  DWORD fdwItalic,         // italic attribute flag   1  0  TRUE FALSE
  DWORD fdwUnderline,      // underline attribute flag  1  0  TRUE FALSE
  DWORD fdwStrikeOut,      // strikeout attribute flag  1  0  TRUE FALSE
  DWORD fdwCharSet,        // character set identifier
  DWORD fdwOutputPrecision,  // output precision
  DWORD fdwClipPrecision,  // clipping precision
  DWORD fdwQuality,        // output quality
  DWORD fdwPitchAndFamily,  // pitch and family
  LPCTSTR lpszFace         // pointer to typeface name string
);
  */


